
local loader = require("generation/loader")
local loading = false
local loaded = false
local map = {}
local canvas
math.randomseed(os.clock())
math.random()
math.random()
function love.load()
end

function love.mousepressed(x,y,b)
	if not loaded then
		if x > 5 and x < 205 and y > 5 and y < 105 then
			--loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*4-map.minx*4,j*4-map.miny*4,4,4); end; end; end; love.graphics.setCanvas(); end,200,150)
			--loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*8-map.minx*8,j*8-map.miny*8,8,8); end; end; end; love.graphics.setCanvas(); end,100,75)
			loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*16-map.minx*16,j*16-map.miny*16,16,16); end; end; end; love.graphics.setCanvas(); end,50,37)
			--loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*32-map.minx*32,j*32-map.miny*32,32,32); end; end; end; love.graphics.setCanvas(); end,25,22)
			loaded = true
			loading = true
		elseif x > 210 and x < 410 and y > 5 and y < 105 then
			loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*2-map.minx*2,j*2-map.miny*2,2,2); end; end; end; love.graphics.setCanvas(); end,400,300)
			loaded = true
			loading = true
		elseif x > 415 and x < 615 and y > 5 and y < 105 then
			loader.start(function(m) loading = false; map = m; canvas = love.graphics.newCanvas(800,600); love.graphics.setCanvas( canvas ); for i = map.minx,map.maxx do for j = map.miny,map.maxy do if map[i][j] == 0 then love.graphics.rectangle("fill",i*1-map.minx*1,j*1-map.miny*1,1,1); end; end; end; love.graphics.setCanvas(); end,800,600)
			loaded = true
			loading = true
		end
	end
end

function love.update(dt)
	if loading then
		loader.update(dt)
	end
end

function love.draw()
	if not loaded then
		love.graphics.rectangle("line",5,5,200,100)
		--love.graphics.rectangle("line",210,5,200,100)
		--love.graphics.rectangle("line",415,5,200,100)
		love.graphics.print("50x37",10,10)
		--love.graphics.print("400x300",215,10)
		--love.graphics.print("800x600",420,10)
	end
	if map.minx then
		love.graphics.draw(canvas)
	love.graphics.setColor(255,0,0,255)
	for j=1,#map do
	for i=1,#map[1] do love.graphics.print(map[j][i],16*(j-1),(i-1)*16) end end
	love.graphics.setColor(255,255,255,255)
	elseif loaded then
		love.graphics.print(math.min(100,math.floor(loader.getDone()*10000)/100),0,0)
		for i,v in ipairs(loader.getActions()) do
			love.graphics.print(v,0,i*20)
		end
	end
end

function love.keypressed(key)
	if key == 'escape'	then love.event.quit() end
	if key == 'n' then loaded=false loading = false map={} end
	end
